package org.wfc.omada.api.device.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * GlobalKnownDeviceOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:26:25.576+08:00[Asia/Shanghai]")

public class GlobalKnownDeviceOpenApiVo   {
  @JsonProperty("mac")
  private String mac;

  @JsonProperty("name")
  private String name;

  @JsonProperty("type")
  private String type;

  @JsonProperty("subtype")
  private String subtype;

  @JsonProperty("deviceSeriesType")
  private Integer deviceSeriesType;

  @JsonProperty("model")
  private String model;

  @JsonProperty("ip")
  private String ip;

  @JsonProperty("ipv6")
  @Valid
  private List<String> ipv6 = null;

  @JsonProperty("uptime")
  private String uptime;

  @JsonProperty("status")
  private Integer status;

  @JsonProperty("lastSeen")
  private Long lastSeen;

  @JsonProperty("cpuUtil")
  private Integer cpuUtil;

  @JsonProperty("memUtil")
  private Integer memUtil;

  @JsonProperty("sn")
  private String sn;

  @JsonProperty("licenseStatus")
  private Integer licenseStatus;

  @JsonProperty("needActive")
  private Boolean needActive;

  @JsonProperty("siteName")
  private String siteName;

  @JsonProperty("tagName")
  private String tagName;

  public GlobalKnownDeviceOpenApiVo mac(String mac) {
    this.mac = mac;
    return this;
  }

  /**
   * Device MAC
   * @return mac
  */
  @ApiModelProperty(value = "Device MAC")


  public String getMac() {
    return mac;
  }

  public void setMac(String mac) {
    this.mac = mac;
  }

  public GlobalKnownDeviceOpenApiVo name(String name) {
    this.name = name;
    return this;
  }

  /**
   * Device name
   * @return name
  */
  @ApiModelProperty(value = "Device name")


  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public GlobalKnownDeviceOpenApiVo type(String type) {
    this.type = type;
    return this;
  }

  /**
   * Device type
   * @return type
  */
  @ApiModelProperty(value = "Device type")


  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public GlobalKnownDeviceOpenApiVo subtype(String subtype) {
    this.subtype = subtype;
    return this;
  }

  /**
   * Switch subtype should be a value as follows: smart: Smart Switch; es: Easy Managed Switch.
   * @return subtype
  */
  @ApiModelProperty(value = "Switch subtype should be a value as follows: smart: Smart Switch; es: Easy Managed Switch.")


  public String getSubtype() {
    return subtype;
  }

  public void setSubtype(String subtype) {
    this.subtype = subtype;
  }

  public GlobalKnownDeviceOpenApiVo deviceSeriesType(Integer deviceSeriesType) {
    this.deviceSeriesType = deviceSeriesType;
    return this;
  }

  /**
   * Device series type. 0 means basic, 1 means pro.
   * @return deviceSeriesType
  */
  @ApiModelProperty(value = "Device series type. 0 means basic, 1 means pro.")


  public Integer getDeviceSeriesType() {
    return deviceSeriesType;
  }

  public void setDeviceSeriesType(Integer deviceSeriesType) {
    this.deviceSeriesType = deviceSeriesType;
  }

  public GlobalKnownDeviceOpenApiVo model(String model) {
    this.model = model;
    return this;
  }

  /**
   * Device model name
   * @return model
  */
  @ApiModelProperty(value = "Device model name")


  public String getModel() {
    return model;
  }

  public void setModel(String model) {
    this.model = model;
  }

  public GlobalKnownDeviceOpenApiVo ip(String ip) {
    this.ip = ip;
    return this;
  }

  /**
   * Device IP
   * @return ip
  */
  @ApiModelProperty(value = "Device IP")


  public String getIp() {
    return ip;
  }

  public void setIp(String ip) {
    this.ip = ip;
  }

  public GlobalKnownDeviceOpenApiVo ipv6(List<String> ipv6) {
    this.ipv6 = ipv6;
    return this;
  }

  public GlobalKnownDeviceOpenApiVo addIpv6Item(String ipv6Item) {
    if (this.ipv6 == null) {
      this.ipv6 = new ArrayList<>();
    }
    this.ipv6.add(ipv6Item);
    return this;
  }

  /**
   * Device IPv6 list
   * @return ipv6
  */
  @ApiModelProperty(value = "Device IPv6 list")


  public List<String> getIpv6() {
    return ipv6;
  }

  public void setIpv6(List<String> ipv6) {
    this.ipv6 = ipv6;
  }

  public GlobalKnownDeviceOpenApiVo uptime(String uptime) {
    this.uptime = uptime;
    return this;
  }

  /**
   * Device uptime
   * @return uptime
  */
  @ApiModelProperty(value = "Device uptime")


  public String getUptime() {
    return uptime;
  }

  public void setUptime(String uptime) {
    this.uptime = uptime;
  }

  public GlobalKnownDeviceOpenApiVo status(Integer status) {
    this.status = status;
    return this;
  }

  /**
   * Device status should be a value as follows: 0: Disconnected; 1: Connected; 2: Pending; 3: Heartbeat Missed; 4: Isolated
   * @return status
  */
  @ApiModelProperty(value = "Device status should be a value as follows: 0: Disconnected; 1: Connected; 2: Pending; 3: Heartbeat Missed; 4: Isolated")


  public Integer getStatus() {
    return status;
  }

  public void setStatus(Integer status) {
    this.status = status;
  }

  public GlobalKnownDeviceOpenApiVo lastSeen(Long lastSeen) {
    this.lastSeen = lastSeen;
    return this;
  }

  /**
   * Device lastSeen
   * @return lastSeen
  */
  @ApiModelProperty(value = "Device lastSeen")


  public Long getLastSeen() {
    return lastSeen;
  }

  public void setLastSeen(Long lastSeen) {
    this.lastSeen = lastSeen;
  }

  public GlobalKnownDeviceOpenApiVo cpuUtil(Integer cpuUtil) {
    this.cpuUtil = cpuUtil;
    return this;
  }

  /**
   * Device cpuUtil
   * @return cpuUtil
  */
  @ApiModelProperty(value = "Device cpuUtil")


  public Integer getCpuUtil() {
    return cpuUtil;
  }

  public void setCpuUtil(Integer cpuUtil) {
    this.cpuUtil = cpuUtil;
  }

  public GlobalKnownDeviceOpenApiVo memUtil(Integer memUtil) {
    this.memUtil = memUtil;
    return this;
  }

  /**
   * Device memUtil
   * @return memUtil
  */
  @ApiModelProperty(value = "Device memUtil")


  public Integer getMemUtil() {
    return memUtil;
  }

  public void setMemUtil(Integer memUtil) {
    this.memUtil = memUtil;
  }

  public GlobalKnownDeviceOpenApiVo sn(String sn) {
    this.sn = sn;
    return this;
  }

  /**
   * Device serial number
   * @return sn
  */
  @ApiModelProperty(value = "Device serial number")


  public String getSn() {
    return sn;
  }

  public void setSn(String sn) {
    this.sn = sn;
  }

  public GlobalKnownDeviceOpenApiVo licenseStatus(Integer licenseStatus) {
    this.licenseStatus = licenseStatus;
    return this;
  }

  /**
   * Device license status(Only for cloud base) should be a value as follows: 0: unActive; 1: Unbind; 2: Expired; 3: active
   * @return licenseStatus
  */
  @ApiModelProperty(value = "Device license status(Only for cloud base) should be a value as follows: 0: unActive; 1: Unbind; 2: Expired; 3: active")


  public Integer getLicenseStatus() {
    return licenseStatus;
  }

  public void setLicenseStatus(Integer licenseStatus) {
    this.licenseStatus = licenseStatus;
  }

  public GlobalKnownDeviceOpenApiVo needActive(Boolean needActive) {
    this.needActive = needActive;
    return this;
  }

  /**
   * Device license status(Only for cloud base).If the value is true, the device is ready to be activated;If the value is false, the device cannot be activated or has already been activated.
   * @return needActive
  */
  @ApiModelProperty(value = "Device license status(Only for cloud base).If the value is true, the device is ready to be activated;If the value is false, the device cannot be activated or has already been activated.")


  public Boolean getNeedActive() {
    return needActive;
  }

  public void setNeedActive(Boolean needActive) {
    this.needActive = needActive;
  }

  public GlobalKnownDeviceOpenApiVo siteName(String siteName) {
    this.siteName = siteName;
    return this;
  }

  /**
   * The name of the site where the device is located
   * @return siteName
  */
  @ApiModelProperty(value = "The name of the site where the device is located")


  public String getSiteName() {
    return siteName;
  }

  public void setSiteName(String siteName) {
    this.siteName = siteName;
  }

  public GlobalKnownDeviceOpenApiVo tagName(String tagName) {
    this.tagName = tagName;
    return this;
  }

  /**
   * Device tag name
   * @return tagName
  */
  @ApiModelProperty(value = "Device tag name")


  public String getTagName() {
    return tagName;
  }

  public void setTagName(String tagName) {
    this.tagName = tagName;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GlobalKnownDeviceOpenApiVo globalKnownDeviceOpenApiVo = (GlobalKnownDeviceOpenApiVo) o;
    return Objects.equals(this.mac, globalKnownDeviceOpenApiVo.mac) &&
        Objects.equals(this.name, globalKnownDeviceOpenApiVo.name) &&
        Objects.equals(this.type, globalKnownDeviceOpenApiVo.type) &&
        Objects.equals(this.subtype, globalKnownDeviceOpenApiVo.subtype) &&
        Objects.equals(this.deviceSeriesType, globalKnownDeviceOpenApiVo.deviceSeriesType) &&
        Objects.equals(this.model, globalKnownDeviceOpenApiVo.model) &&
        Objects.equals(this.ip, globalKnownDeviceOpenApiVo.ip) &&
        Objects.equals(this.ipv6, globalKnownDeviceOpenApiVo.ipv6) &&
        Objects.equals(this.uptime, globalKnownDeviceOpenApiVo.uptime) &&
        Objects.equals(this.status, globalKnownDeviceOpenApiVo.status) &&
        Objects.equals(this.lastSeen, globalKnownDeviceOpenApiVo.lastSeen) &&
        Objects.equals(this.cpuUtil, globalKnownDeviceOpenApiVo.cpuUtil) &&
        Objects.equals(this.memUtil, globalKnownDeviceOpenApiVo.memUtil) &&
        Objects.equals(this.sn, globalKnownDeviceOpenApiVo.sn) &&
        Objects.equals(this.licenseStatus, globalKnownDeviceOpenApiVo.licenseStatus) &&
        Objects.equals(this.needActive, globalKnownDeviceOpenApiVo.needActive) &&
        Objects.equals(this.siteName, globalKnownDeviceOpenApiVo.siteName) &&
        Objects.equals(this.tagName, globalKnownDeviceOpenApiVo.tagName);
  }

  @Override
  public int hashCode() {
    return Objects.hash(mac, name, type, subtype, deviceSeriesType, model, ip, ipv6, uptime, status, lastSeen, cpuUtil, memUtil, sn, licenseStatus, needActive, siteName, tagName);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GlobalKnownDeviceOpenApiVo {\n");
    
    sb.append("    mac: ").append(toIndentedString(mac)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    subtype: ").append(toIndentedString(subtype)).append("\n");
    sb.append("    deviceSeriesType: ").append(toIndentedString(deviceSeriesType)).append("\n");
    sb.append("    model: ").append(toIndentedString(model)).append("\n");
    sb.append("    ip: ").append(toIndentedString(ip)).append("\n");
    sb.append("    ipv6: ").append(toIndentedString(ipv6)).append("\n");
    sb.append("    uptime: ").append(toIndentedString(uptime)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    lastSeen: ").append(toIndentedString(lastSeen)).append("\n");
    sb.append("    cpuUtil: ").append(toIndentedString(cpuUtil)).append("\n");
    sb.append("    memUtil: ").append(toIndentedString(memUtil)).append("\n");
    sb.append("    sn: ").append(toIndentedString(sn)).append("\n");
    sb.append("    licenseStatus: ").append(toIndentedString(licenseStatus)).append("\n");
    sb.append("    needActive: ").append(toIndentedString(needActive)).append("\n");
    sb.append("    siteName: ").append(toIndentedString(siteName)).append("\n");
    sb.append("    tagName: ").append(toIndentedString(tagName)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

